package com.gx.obe.config;

import java.io.File;
import java.io.IOException;

import org.eclipse.core.runtime.FileLocator;

import com.gx.obe.config.utils.ProjectUtils;
import com.gx.obe.config.utils.PropertiesUtils;

/**
 * @Description: 
 * @author guoyr
 */
public class ConfigConstants {

	/**
	 * 对应服务器编码
	 */
	// 开评标工具服务
	public static final String SERVER_NAME = "serverName";
	public static final String SERVER_URL = "serverUrl";
	public static final String NET_SERVICE = "netService";
	public static final String PRODUCT_TYPE = "productType";
	public static final String PRODUCT_TYPE_FINAL = "final";
	public static final String PRODUCT_TYPE_TEST = "test";
	//license服务端认证地址
	public static final String OBE_LICENSE_SERVICE_URL = "obeLicenseServerUrl";
	//web服务端地址
	public static final String OBE_WEB_SERVICE_URL = "obeWebServerUrl";
	
	// 设置多轮报价截止之间与当前时间最小间隔(分钟)
	public static final String INTERVALS_TIME = "intervalsTime";
	// 系统版本
	public static final String VERSION = "version";
	public static final String VERSION_UPDATE_TYPE = "versionUpdateType";
	// 检查最新版本
	public static final String CHECK_NEW_VERSION = "checkNewVersion";
	// 系统版权
	public static final String COPYRIGHT = "copyright";
	
	public static final String MANAGEMENT_TITLE = "managementTitle";
	public static final String EVALUATION_TITLE = "evaluationTitle";
	
	// 投标文件路径
	public static final String BID_FILE_PATH = "bidFilePath";
	
	// 文件接收服务器的端口
	public static final String RECEIVE_PORT = "receive.port";
	
	// 模板存放位置
	public static final String TEMPLATE_PATH = "template";
	
	// CA引擎
	public static final String CA_ENGINE = "caEngine";
	
	public static final String TECHNICAL_SUPPORT = "technicalSupport";
	
	/**
	 * 重新回退评标
	 */
	public static final String REBACK_EVALUATION = "rebackEvaluation";
	/**
	 * CA登录
	 */
	public static final String USE_CA_LOGIN = "useCaLogin";
	/**
	 * CA登录
	 */
	public static final String CA_LOGIN = "caLogin";
	/**
	 * 使用自定义的CA登录窗口
	 */
	public static final String USE_VERIFY_UKEY_PIN = "useVerifyUkeyPin";
	
	/**
	 * 项目经理或评标专家是否需要验证评标室机位
	 */
	public static final String VERIFY_EVAL_MACHINE_MANAGER = "verifyEvalMachineManager";
	public static final String VERIFY_EVAL_MACHINE_EXPERT = "verifyEvalMachineExpert";
	/**
	 * 使用公共的数据库
	 */
	public static final String USE_PUBLIC_DB = "usePublicDb";
	
	// 按评标室分项目
	public static final String GROUPBY_EVALBIDROOM = "groupByEvalBidRoom";
	
	// 当前时间（数据库服务器时间或时间戳服务器时间）
	public static final String NOW_TIME_TYPE = "nowTypeType";
	
	// 当前评标室id
	public static final String EVALBIDROOM_ID = "evaluationRoomId";
	
	// 使用机位
	public static final String USE_MACHINE_LOCK = "useMachineLock";
	
	// 评审报告
	public static final String EVALUATION_REPORT = "evaluationReport";
	
	// 上传开标结果的接口
	public static final String UPLOAD_BID_OPENING_OPINION = "uploadOpenBidResult";
	
	// 上传评标结果的接口
	public static final String UPLOAD_EVALUATE_RESULT = "uploadEvaluateResult";
	
	// 专家默认密码
	public static final String EXPERT_DEFAULT_PASSWORD = "defaultPassword";
	
	// 评审界面的指标是否横轴
	public static final String FACTOR_IS_HORIZONTAL = "factorIsHorizontal";
	
	public static final String MENU_TYPE = "menuType";
	
	// 金额单位
	public static final String PRICE_UINT = "priceUint";
	
	// 匿名
	public static final String ANONYMOUS = "anonymous";
//	
//	//  是否远程集中解密
//	public static final String REMOTE_FOCUS_DECRYPT = "remoteFocusDecrypt";
	
	// 使用开标人角色
	public static final String USE_OPENING_USER = "useOpeningUser";
	
	//  在开标界面是否隐藏已废标投标人
	public static final String HIDE_REVOKE_SUPPLIER = "hideRevokeSupplier";
	
	// 二阶段评标法在开标终端和唱标终端是否隐藏投标报价（默认隐藏）
	public static final String TWO_STAGE_HIDE_TENDERPRICE = "twoStageHideBidPrice";
	
	// 设置评标专家在评标结束前，是否允许查看投标人的投标报价
	public static final String VIEW_BID_PRICE = "viewBidPrice";
	
	// 设置评标专家在评标结束前，是否允许查看投标人的价格得分
	public static final String VIEW_PRICE_SCORE = "viewPriceScore";
	
	// 设置评标专家在评标结束前，是否允许查看投标人的开标结果
    public static final String VIEW_OPEN_RESULT = "viewOpenResult";
    
    // 设置评标专家在评标结束前，是否允许查看投标人的评标结果
    public static final String VIEW_EVAL_RESULT = "viewEvalResult";
	
	// 开标界面和唱标界面是否显示项目预算和超预算
	public static final String SHOW_BUDGET = "showBudget";
	
	// 唱标语音(TTS)接口
	public static final String TTS = "tts";
	
	// 唱标语速
	public static final String SPEED = "speed";
	
	// 唱标音量
	public static final String VOLUME = "volume";
	
	// 唱标时过滤的字符
	public static final String FILTER_CHAR = "filterChar";
	
	// 唱标时过滤括号内容
	public static final String FILTER_BRACKET_CONTENT = "filterBracketContent";
	
	// 唱标时唱项目或分包的或称
	public static final String SING_TENDERNAME = "singTenderName";
	
	// 唱标时唱投标限价
	public static final String SING_BID_PRICE_LIMIT = "singBidPriceLimit";
	
	// #报表是否pdf
	public static final String PDF_REPORT = "pdfReport";
	/**
	 * 不足三家限制
	 */
	public static final String LESS_THAN_THREE_FILTER = "lessThanThreeFilter";
	
	/**
	 * 评标专家限制
	 */
	public static final String EXPERT_LIMIT = "expertLimit";
	
	/**
	 * 专家在完成评标审时是否进行签章
	 */
	public static final String EXPERT_SIGN = "expertSign";
	
	/**
	 * 开标结果中显示上报材料
	 */
	public static final String SHOW_UPLOAD_MATERIAL = "showUploadMaterial";
	
	/**
	 * ca签章控件类型
	 */
	public static final String CA_SIGNATURE_PDF = "caSignaturePdf";
	/**
	 * 手写签字控件类型
	 */
	public static final String HAND_SIGNATURE_PDF = "handSignaturePdf";
	/**
	 * 扫码签字控件类型
	 */
	public static final String SAOMA_SIGNATURE_PDF = "saomaSignaturePdf";
	
	/**
	 * 调用app服务的方法
	 */
	public static final String CAL_APP_SERVICE_TYPE = "callAppServiceType";
	/**
	 * 调用app服务是否并行
	 */
	public static final String APP_SERVICE_IS_PARALLEL = "appServiceIsParallel";
	
	/**  
	 * 	扫码签章模式
	 */
	public static final String APP_SERVICE_SIGN_MODE ="appServiceSignMode";

	/**
	 * 多文件批量签名
	 */
	public static final String BATCH_FILE_SIGNATURE = "batchFileSignature";
	
	/**
	 * 存在关键字时不显示定位签名
	 */
	public static final String HIDE_LOCATION_SIGN_EXIS_TKEY = "hideLocationSignExistKey";
	
	/**
	 * 在批量签字的时候不显示一键签名
	 */
	public static final String HIDE_KEY_SIGN_IF_BATCH_SIGN = "hideKeySignIfBatchSign";
	/**
	 * 签名印章宽度
	 */
	public static final String SEAL_WIDTH = "sealWidth";
	/**
	 * 签名印章高度
	 */
	public static final String SEAL_HEIGHT = "sealHeight";
	
	/**
	 * 查看我的报表默认用控件加载
	 */
	public static final String OPEN_REPORT_BY_OLE = "openReportByOle";
	
	// 插件注册
	public static final String OCX_REGSVR = "OCX_REGSVR32";
	// pdf控件类型DianJu;JinGe
	public static final String PDF_ACTIVE_TYPE = "pdfActiveType";

	// 信手书签名服务类型，0:信手书服务器; 1云签名
	public static final String HAND_SIGN_TYPE = "handSignType";
	
	// 签名服务器地址
	public static final String HAND_SIGN_SERVER_URL = "handSignServerUrl";
	/**
	 * 信手书签名根证书
	 */
	public static final String HAND_SIGN_CERT = "serverCert.der";
	/**
	 * 信手书服务配置
	 */
	public static final String HAND_SIGN_CONFIG = "AnySignClient.ini";
	
	/**
	 * 缓存5家供应商的标书文件
	 */
	public static final String BIDFILE_CACHE_COUNT = "bidFileCacheCount";
	/**
	 * 每家家供应商缓存数量
	 */
	public static final String FILE_CACHE_COUNT = "fileCacheCount";
	/**
	 * 显示加载标书前的提示
	 */
	public static final String SHOW_ONLOAD_FILE_TIPS = "showOnloadFileTips";
	/**
	 * 对比标书数量
	 */
	public static final String COMPARE_FILE_COUNT = "compareFileCount";
	
	/**
	 * 辅助开标
	 */
	public static final String ASSIST_BIDOPENING = "assistBidopening";
	
	/**
	 * 在完成开标前是否需要先停止
	 */
	public static final String NEED_STOP_BIDOPENING_FIRST = "needStopBidopeningFirst";
	
	// 项目列表分页数设置
	public static final String PROJECT_PAGE_SIZE = "projectPageSize";
	// 使用摄像头
	public static final String USE_CAMERA = "useCamera";
	
	// 视频监控接口
	public static final String VIDEO = "video";
	
	// 视频IP地址
	public static final String VIDEO_IP = "videoIp";
	
	// 视频端口
	public static final String VIDEO_PORT = "videoPort";
	
	// FTP IP地址
	public static final String FTP_IP = "ftpIp";
	
	// FTP端口
	public static final String FTP_PORT = "ftpPort";
	
	// ftp用户名
	public static final String FTP_USERNAME = "ftpUsername";
	
	// ftp密码
	public static final String FTP_PASSWORD = "ftpPassword";
	
	// 上传评标结果的接口
	public static final String UPLOAD_FINAL_EVALUATE_RESULT = "UploadOpenBinFinalResultAndDocument";
	
	// 公信区块链IP地址
	public static final String GXQUL_IP = "gxqklIp";
	
	/**
	 * 标书封密情况
	 */
	public static final String SEAL_SITUATION = "sealSituation";
	
	/**
	 * 资审项目隐藏经济标
	 */
	public static final String HIDDEN_PREEVALUATION_PRICE = "hiddenPrevaluationPrice";

	
	
	/**
	 * excel默认从当前行数读取
	 */
	public static final String EXCEL_ROW_START = "excelRowStart";
	/**
	 * excel默认从当前列数读取
	 */
	public static final String EXCEL_COLUMN_START = "excelColumnStart";
	/**
	 * 视频录制路径
	 */
	public static final String VIDEO_FILE_PATH = "videoFilePath";
	/**
	 * 视频直播地址
	 */
	public static final String LIVING_ADDRESS = "livingAddress";
	
	/**
	 * 开标界面供应商样式
	 */
	public static final String BID_OPENING_SUPPLIER_SYTLE = "bidOpeningSupplierSytle";
	
	/**
	 * 直播地址
	 */
	public static final String VIDEO_LIVE_URL = "videoLiveUrl";
	
	/**
	 * 直播类型
	 */
	public static final String LIVING_TYPE = "livingType";
	
	/**
	 * 是否使用自动下载
	 */
	public static final String IS_USE_AUTOMATIC_DOWNLOAD = "isUseAutomaticDownload";
	
	/**
	 * 评标界面标书区域是否默认显示清标意见
     */
    public static final String DEFAULT_SHOW_BID_FILE_OPINION = "isShowBidFileOpinion";
	
	/**
	 * 是否使用FTP检查新版本
	 */
	public static final String IS_USE_FTP_CHECK_NEW_VERSION = "isUseFtpCheckNewVersion";
	
	public static final String SIGN_WIDTH = "signWidth";
	
	public static final String SIGN_HEIGHT = "signHeight";
	
	/**
	 * 旧字符集名称
	 */
	public static final String OLD_CHARSET_NAME = "oldCharsetName";

	/**
	 * 新字符集名称
	 */
	public static final String NEW_CHARSET_NAME = "newCharsetName";

	/**
	 * 按项目开标界面中显示包件的行数
	 */
	public static final String TENDER_PACK_ROW_NUM = "tenderPackRowNum";
	/**
	 * 开标界面中是否显示确认状态
	 */
	public static final String SHOW_CONFIRM_STATUS = "showConfirmStatus";
	/**
	 * 开标界面中是否显示签到状态
	 */
	public static final String SHOW_SIGN_INFO_STATUS = "showSignInfoStatus";
	/**
	 * 开标界面全屏显示
	 */
	public static final String BID_OPENING_FULLSCREEN = "bidOpeningFullscreen";
	/**
	 * 开标界面全屏显示
	 */
	public static final String SHOW_OPENING_TIPS = "showOpeningTips";
	/**
	 * 评标是使用专用pdf控件
	 */
	public static final String USE_SPECIAL_PDF = "useSpecialPdf";
	/**
	 * CA引擎
	 */
	//指纹和手写图合并类型 这里设备0表示没有指纹   1，2，3，4，5分别表示指纹在手写的上、下、左、右、中，中表示重叠, 默认为5
	public static final String MERGETYPE = "mergetype";
	//设置手写板手写透明度
	public static final String ALPHA = "alpha";
	//指纹图二值化阈值
	public static final String THRESHOLD = "threshold";
	
	/**
	 * 标书服务器ip地址
	 */
	public static final String TORRENT_SERVER = "torrentServer";
	/**
	 * 标书服务器端口
	 */
	public static final String TORRENT_PORT = "torrentPort";
	/**
	 * 进行urlEncoder转码
	 */
	public static final String URL_ENCODER = "urlEncoder";
	/**
	 * 开标大厅中显示当前时间
	 */
	public static final String SHOW_NOW_TIME = "showNowTime";
	
	/**
	 * 允许导入标书
	 */
	public static final String ALLOW_IMPORT_BIDFILE = "allowImportBidFile";
	
	/**
	 * 允许查看得分评审汇总
	 */
	public static final String SHOW_SUMMARY_SCORE = "showSummaryScore";
	
	/**
	 * 允许查看符合性评审汇总
	 */
	public static final String SHOW_SUMMARY_COMPLIANCE = "showSummaryCompliance";
	
	/**
	 * 默认评标进度
	 */
	public static final String DEFAULT_STEP_PROGRESS = "defaultStepProgress";
	
	/**
	 * 默认评审方式
	 */
	public static final String DEFAULT_EVALUATION_TYPE = "defaultEvaluationType";
	
	/**
	 * 默认推荐家数
	 */
	public static final String DEFAULT_RECOMMONED_COUNT = "defaultRecommonedCount";
	
	/**
	 * 专家组长在评标过程中可以查看评标结果
	 */
	public static final String VIEW_EVALUATION_RESULT = "viewEvaluationResult";
	/**
	 * 当前评标步骤评审完是否可以查看汇总结果
	 */
	public static final String VIEW_STEP_SUMMARY_RESULT = "viewStepSummaryResult";
	/**
	 * 是否可以查看我的汇总结果
	 */
	public static final String VIEW_MY_SUMMARY_RESULT = "viewMySummaryResult";
	
	/**
	 * 开标结果和报价界面是否是显示未签到的供应商
	 */
	public static final String FILTER_NO_SIGN_SUPPLIER = "filterNoSignSupplier";
	/**
	 * 工程量清单类型
	 */
	public static final String BILL_TYPE = "billType";
	
	/**
	 * 多轮报价类型
	 */
	public static final String MULITI_ROUND_PRICE = "multiRoundPriceType";
	
	/**
	 * 多轮报价最大轮次
	 */
	public static final String MAX_ROUND = "maxRound";
	
	/**
	 * 解密方式
	 */
	public static final String DECRYPT_TYPE = "decryptType";
	
	/**
	 * 单报价
	 */
	public static final String SINGLE_BID_PRICE = "singleBidPrice";
	
	/**
	 * 开标室LED内容
	 */
	public static final String OPENINGROOM_LED_CONTENT = "openingroomLedContent";
	/**
	 * Led循环滚动
	 */
	public static final String LED_CIRCLE_SCROLL = "ledCircleScroll";
	public static final String LED_SCROLL_TIME = "ledScrollTime";
	public static final String LED_SCROLL_STEP = "ledScrollStep";
	
	/**
	 * 解压缩字符集编码
	 */
	public static final String ZIP_ENCODING = "ZIP_ENCODING";
	
	/**
	 * 开标大厅、评标大厅使用加宽大屏
	 */
	public static final String ROOM_USE_WIDEN_SCREEN_ = "roomuseWindenScreen";
	public static final String[] COPY_PROPERITES = new String[]{
		ConfigConstants.BID_FILE_PATH, 
		ConfigConstants.FTP_IP, ConfigConstants.FTP_PORT, ConfigConstants.FTP_USERNAME, ConfigConstants.FTP_PASSWORD
	};
//	public static final String[] COPY_ENUM = new String[]{I18NEnum.COMPLIANCE_FACTOR, I18NEnum.SCORE_FACTOR, I18NEnum.PRICE_FACTOR, I18NEnum.BILL_FACTOR};
	
//	public static final String CA_NAME_BJ = "北京CA";
//	public static final String CA_NAME_BJ_V2 = "北京CA_V2.0.1";
//	public static final String CA_NAME_AH = "安徽CA";
//	public static final String CA_NAME_SHD = "山东CA";
//	public static final String CA_NAME_DEMO = "演示CA";
//	public static final String CA_NAME_CFCA = "CFCA";
//	public static final String CA_NAME_JSCA = "苏州CA";// 
//	public static final String CA_NAME_JSCA_V2 = "苏州CA_V2.0.1";// 
//	public static final String CA_ENGINE_BJ = "BJCASecurityEngine";
//	public static final String CA_ENGINE_BJ_V2 = "BJCASecurityEngineV2";
//	public static final String CA_ENGINE_AH = "AHCASecurityEngine";
//	public static final String CA_ENGINE_SHD = "SDCASecurityEngine";
//	public static final String CA_ENGINE_DEMO = "DemoCASecurityEngine";
//	public static final String CA_ENGINE_CFCA = "CFCASecurityEngine";
//	public static final String CA_ENGINE_JSCA = "JSCASecurityEngine";
//	public static final String CA_ENGINE_JSCA_V2 = "JSCASecurityEngineV2";
	
	/**
	 * 上传开标一览表类型
	 */
	public static final String UPLOAD_BIDPRICE_TYPE = "uploadBidPriceType";
	
	
	 
	/**
	 * 	今日不在下载
	 */
	public static final String NO_DOWNLOAD_TODAY = "NO_DOWNLOAD_TODAY";
 
	/**
	 * 	下载项目最晚时间
	 */
	public static final String LAST_DOWNLOAD_PROJECT_TIME = "lastDownloadProjectTime";
	
	/**
	 * 使用视频会议
	 */
	public static final String USE_VIDEO_MEETING = "useVideoMeeting";
	
	/**
	 * 使用视频会议类型
	 */
	public static final String VIDEO_MEETING_TYPE = "videoMeetingType";
	
	/**
	 * 视频会议系统服务器地址
	 */
	public static final String MEETING_SERVER_ADDRESS = "meetingServerAddress";
	/**
	 * 视频会议系统客户端服务器地址
	 */
	public static final String MEETING_CLEINT_SERVER_ADDRESS = "meetingCleintServerAddress";
	public static final String MEETING_CLEINT_SERVER_PORT = "meetingCleintServerPort";
	/**
	 * 二维码服务地址
	 */
	public static final String QR_CODE_SERVCER_ADDRESS = "qrCodeServcerAddress";
	public static final String QR_CODE_STATIC_SERVCER_ADDRESS = "qrCodeStaticServcerAddress";
	
	/**
	 * 平台标识码
	 */
	public static final String PLATFORM_CODE = "platformCode";
	
	/**
	 * openOffice 配置
	 */
	public static final String OPENOFFICE_SERVER_URL = "openOfficeServerUrl";
	
	public static final String OPENOFFICE_SERVER_port = "openOfficeServerPort";
	
	/**
	 * 代理服务配置地址
	 * 
	 */
	public static final String USE_PROXY_STATUS = "useProxyStatus";// 代理地址
	public static final String PROXY_ADDRESS = "proxyAddress";// 代理地址
	public static final String PROXY_PORT = "proxyPort";//代理端口
	public static final String PROXY_USER_NAME = "proxyUserName";//代理用户名
	public static final String PROXY_PASS_WORD = "proxyPassWord";//代理密码
	public static final String PROXY_VERIFY_STATUS = "proxyVerifyStatus";//代理密码
	
	
	public static final String ALIYUN_APP_CODE ="aliyunAppCode";
	
	
	
	
	public static final String CONFIG_PROPERTIES_UPDATE_TIEM = "updateTime";//配置文件升级时间
	
	public static final String TEMPLATE_UPDATE_TIME = "templateUpdateTime";//模板更新时间
	
	public static final String PASSWORD_PATTERN = "passwordPattern";//密码校验规则
	public static final String PASSWORD_PATTERN_TIPS = "passwordPatternTips";//密码校验提示
	
	/**
	 * @Description: 解析招标投标报价
	 */
	public static final String PARSE_BIDDING_BID_PRICE = "parseBiddingBidPrice";
	
	/**
	 * 上传下载开标一览表签字是否用压缩包
	 */
	public static final String BID_OPEN_REPORT_USE_ZIP = "bidOpenReportUserZip";
	
	public static final String EVAL_FULL_SCREEN = "evalFullScreen";
	
	public static boolean copyConfig(String productType) {
		
		try {
			String propertsPath = FileLocator.toFileURL(ProjectUtils.getURL(ConfigActivator.getDefault(), "config.properties")).getPath();
			File targetPropertiesFile = new File(propertsPath);
			if(targetPropertiesFile.exists()) {
				String srouceFileName = targetPropertiesFile.getName().substring(0, targetPropertiesFile.getName().indexOf(".")).concat("_").concat(productType).concat(targetPropertiesFile.getName().substring(targetPropertiesFile.getName().indexOf(".")));
				File sourcePropertiesFile = new File(targetPropertiesFile.getParentFile().getAbsolutePath().concat(File.separator).concat(srouceFileName));
				if(sourcePropertiesFile.exists()) {
					PropertiesUtils.copyAllProperties(sourcePropertiesFile.getAbsolutePath(), targetPropertiesFile.getAbsolutePath());
					return true;
				}else {
//					LOG.error("没有设置正式版本配置信息！");
				}
			}
		} catch (IOException e) {
		}
		return false;
	}
	//web服务端地址
		public static final String AUXILIARY_SERVICE_URL = "auxiliaryServiceUrl";
		
		/**
	     * 评标界面标书区域是否默认显示清标意见
	     */
//	    public static final String IS_SHOW_FACTOR_OPINION = "isShowFactorOpinion";
		
	    public static final String SHOW_TYPE = "showType";
}
